function [u, a, b] = BIL(y,D,na,nb,lambda)
% [u, a, b] = BIL(y,D,na,nb,lambda)
% See http://arxiv.org/abs/1312.2060 for further explanation.

n = max(na, nb)+1;
[N m] = size(D);
cvx_begin quiet
variables X(m,nb) traceVector(N,nb+na) DX(N,nb) a(na)
minimize(norm_nuc(X) )
subject to
DX==D*X
for t=n:N
    for i=1:nb
        traceVector(t,i) == DX(t-i+1,i);
    end
    for j=1:na
        traceVector(t,j+nb) == a(j)*y(t-j);
    end
end
abs( sum(traceVector(n:N,:),2) - y(n:N) )<=lambda
cvx_end


[uu ss vv]=svd(full(X));

if ss(1,1)/ss(2,2)<10
    disp('The solution is not rank 1.')
end

u = D*uu(:,1)*sqrt(ss(1,1));
b = vv(:,1)*sqrt(ss(1,1));
